package com.pqs9900.serviceImpl.HisData;

import com.pqs9900.mapper.HisData.DataHarmrateIMapper;
import com.pqs9900.pojo.HisData.DataHarmrateI;
import com.pqs9900.service.HisData.DataHarmrateIService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.concurrent.ThreadPoolTaskExecutor;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.Callable;
import java.util.concurrent.Future;

/** @Author denghuajun
 * @Description //TODO
 * @Date  2018/12/17 10:53
 **/
@Service
public class DataHarmrateIServiceImpl implements DataHarmrateIService {

    private static final Logger logger= LoggerFactory.getLogger(DataHarmrateIServiceImpl.class);
    @Autowired
    private ThreadPoolTaskExecutor taskExecutor;

    @Autowired
    private DataHarmrateIMapper dataHarmrateIMapper;
    @Override
    public int saveDataHarmrateI(DataHarmrateI dataHarmrateI) {
        return dataHarmrateIMapper.insert(dataHarmrateI);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public int insertDataHarmrateI(List<DataHarmrateI> list) {
        return dataHarmrateIMapper.insertDataHarmrateI(list);
    }


    /**
     * 采用线程池进行数据入库
     * @param listDataHarmrateI 谐波电流幅值数据
     */
    @Override
    public Future insertDataHarmrateIExecutor(List<DataHarmrateI> listDataHarmrateI) {
        int inum = 100 ;//每次解析入库条目数
        Callable callable = new Callable() {
            @Override
            public Object call() throws Exception {
                int nCyclicTimes;//循环次数（总长度/批量入库条目数）
                int fromIndex,toIndex;//获取数据的起始和结束下标
                try {
                    nCyclicTimes = (int) Math.ceil(listDataHarmrateI.size() / (double) inum);
                    List<DataHarmrateI> tmpListDataHarmrateI = new ArrayList<>();
                    for (int i = 0; i < nCyclicTimes; i++) {
                        tmpListDataHarmrateI.clear();
                        //假如是最后一次循环则获取循环到结束
                        fromIndex = i * inum;
                        if (i == nCyclicTimes - 1) {
                            toIndex = listDataHarmrateI.size();
                        } else {
                            toIndex = (i + 1) * inum;
                        }
                        //可以先按下标截取，再入库
                        tmpListDataHarmrateI.addAll(listDataHarmrateI.subList(fromIndex, toIndex));
                        // TODO 做批量入库的操作
                        dataHarmrateIMapper.insertDataHarmrateI(tmpListDataHarmrateI);
                    }
                    return "SUCCESS";
                } catch (Exception e) {
                    logger.error("谐波电流幅值导入异常，异常是" + e.toString());
                    return "FAIL";
                }
            }
        };
        return taskExecutor.submit(callable);
    }
}
